// ̧قDoxygenpɏĂ܂B
/*! \file ********************************************************************
*
* Atmel Corporation
*
* - ̧		: SMBslave.h
* - ߲		: IAR EWAAVR 4.10b
*
* - xҰ		: avr@atmel.com
*
* - x޲	: TWIgp\ȑSAVR޲
*				  ATmega32pɏĂ܂B
*
* - pLq	: AVR316 - SMBus]u
*
* - 		: SMBSlave.cpͯ ̧(̌`Ԑݒ荀ڂ܂)
*
* $Revision: 1.5 $
* $Date: Thursday, September 29, 2005 12:10:38 UTC $
*****************************************************************************/


#ifndef __SMB_SLAVE_H__
#define __SMB_SLAVE_H__

/*****************************************************************************
* `Ԑݒ荀
* SMBusײނƎݒ肷ɂ͈ȉ̍sҏWĂB
*****************************************************************************/
/*
 * PECxɑ΂Ĉȉ2s̓1̒߂OĂB
 * ̍s߂ɂƁAPECxȂɂȂ܂B
 */
#define SMB_USE_PEC_LOOKUP			//!< PECpCRCQƕ\gp
//#define SMB_USE_PEC_CALCULATION	//!< PECpCRCvZgp

//! {u7ޯď]uڽ
#define SMB_OWN_ADDRESS		0x05	// \ڽ(pł͂܂B)

/*!
 *  򏑂݁A򏑂ǂݏĂяoɑ΂őMް ޲Đ(ől=32)
 */
#define SMB_RX_MAX_LENGTH	32

/*
 *  ǂݍ݁A򏑂ǂݏĂяoɑ΂ő呗Mް ޲Đ(ől=32)
 */
#define SMB_TX_MAX_LENGTH	32

/*****************************************************************************
* `Ԑݒ荀ڗ̈I
*****************************************************************************/

#ifdef SMB_USE_PEC_LOOKUP
#define SMB_SUPPORT_PEC
#endif

#ifdef SMB_USE_PEC_CALCULATION
#define SMB_SUPPORT_PEC
#endif

#define SMB_COMMAND_CODE_LENGTH		1	//! ߕ̒
#define SMB_BYTE_COUNT_LENGTH		1	//! ޲Đ̒
#define SMB_PEC_LENGTH				1	//! PEC̒

//! Mޯ̧͐޲Ă܂ނ߂ɏ[ȑ傫łȂ΂Ȃ܂B
#ifdef SMB_SUPPORT_PEC
#define SMB_RX_BUFFER_LENGTH	(SMB_COMMAND_CODE_LENGTH + SMB_BYTE_COUNT_LENGTH + SMB_RX_MAX_LENGTH + SMB_PEC_LENGTH)
#else
#define SMB_RX_BUFFER_LENGTH	(SMB_COMMAND_CODE_LENGTH + SMB_BYTE_COUNT_LENGTH + SMB_RX_MAX_LENGTH)
#endif

/*!
 * Mޯ̧͐޲Ă܂ނ߂ɏ[ȑ傫łȂ΂Ȃ܂B
 * PEC̏ꏊ͂ꂪMޯ̧ɌĔzuȂ̂ŕKv܂B
 */
#define SMB_TX_BUFFER_LENGTH	(SMB_BYTE_COUNT_LENGTH + SMB_TX_MAX_LENGTH)

//! SMBusʐMŏ]uڽɕt鏑ޯĒl
#define SMB_WRITE			0

//! SMBusʐMŏ]uڽɕtǂݍޯĒl
#define SMB_READ			1

//! ޯĕtł̏]uڽl(PECvZ/QƂɎgp)
#define SMB_OWN_ADDRESS_W	((SMB_OWN_ADDRESS << 1) | SMB_WRITE)

//! ǂݍޯĕtł̏]uڽl(PECvZ/QƂɎgp)
#define SMB_OWN_ADDRESS_R	((SMB_OWN_ADDRESS << 1) | SMB_READ)

//! PECvZŎgpCRC
#define SMB_CRC_POLYNOME	0x07	// X2+X1+1

/*! \brief үނ̒PECϸ
 *
 *  ϸۂүނn𒲂ׂ̂Ɏgp邱Ƃł܂Bn+1PEC
 *  ĂꍇPEC܂B
 *
 *  үނsȒA܂PEC̏ꍇ͋UԂ܂B
 */
#ifdef SMB_SUPPORT_PEC
#define RX_COUNT_AND_PEC_CHECK(n)	(smb->rxCount == n || (smb->rxCount == (n + 1) && smb->pec == 0))
#else
#define RX_COUNT_AND_PEC_CHECK(n)	(smb->rxCount == n)
#endif

#define SMB_STATE_IDLE					0x00	//!< ُԔԍ
#define SMB_STATE_READ_REQUESTED		0x01	//!< 呕u̓ǂݍݗvԔԍ
#define SMB_STATE_WRITE_REQUESTED		0x02	//!< 呕ȕݗvԔԍ
#define SMB_STATE_WRITE_READ_REQUESTED	0x03	//!< 呕ȕ݌ɓǂݍ݂̗vԔԍ

#define TRUE	1
#define FALSE	0

// ֐^錾
void SMBusInit(void);
void SMBEnable(void);
void SMBDisable(void);
unsigned char SMBError(void);
void SMBcrc(unsigned char data);

/*! \brief SMBusײނɂĎgpSϐ
 *
 *  SMBData\̂SMBusײނɂēIɎgpSĂ̕ϐ܂݂܂B
 */
typedef struct SMBData
{
  unsigned char txLength;							//!< M
  unsigned char txCount;							//!< Mv
  unsigned char rxCount;							//!< Mv
  unsigned char state:2;							//!< SMBusײޏ׸
  unsigned char volatile enable : 1;				//!< vɑ΂ACK׸
  unsigned char volatile error : 1;					//!< ُ׸
#ifdef SMB_SUPPORT_PEC
  unsigned char pec;								//!< isүނPECl
#endif //SMB_SUPPORT_PEC
  unsigned char rxBuffer[SMB_RX_BUFFER_LENGTH];		//!< Mޯ̧
  unsigned char txBuffer[SMB_TX_BUFFER_LENGTH];		//!< Mޯ̧
} SMBData;

/*! \brief SMBusײނɊ֘AS׸ނ\
 *
 *  SMBGlobalFlags\̂SMBusײނɊ֘AS׸ނ܂݂܂B
 */
/*
typedef struct SMBGlobalFlags
{
  unsigned char enable : 1;		//!< vɑ΂ACK׸
  unsigned char error : 1;		//!< ُ׸
} SMBGlobalFlags;
*/

#endif
